﻿@addTagHelper *, Microsoft.AspNetCore.Mvc.TagHelpers
@model CyberaniumModels.FunctionDashboard
@using Microsoft.AspNetCore.Http;
@{
    ViewData["Title"] = "Index";
    if (!string.IsNullOrEmpty(TempData["success"]?.ToString()))
    {
        <script>
        toastr.success('@TempData["success"]')
        </script>
    }
    else if (!string.IsNullOrEmpty(TempData["error"]?.ToString()))
    {
        <script>
        toastr.error('@TempData["error"]')
        </script>
    }
}
<script src="~/Script/Master/Layout.js"></script>
<script>
    $(document).ready(function () {
        $('.multiple').multiselect({
            enableFiltering: true,
            includeSelectAllOption: true
        });
        if ($('#Id').val() > 0) {
            showForm()
            GetFunctionsByOrgId($('#Id').val(), 0);
        }
    });
</script>
<section>
    <div class="right_section">
        <div class="titile_heading" id="title_List">
            <h1>Function Dashboard</h1>
            <div class="titile_line"></div>
        </div>
        <div class="col-lg-12 col-md-12 col-sm-12 col-xs-12">
            <div class="right_panel">
                <div class="right_content">
                    <div class="service_line" id="dvForm">
                        @*<div style="display:none;" id="dvForm">*@
                        <form asp-area="ApplicationManagement" asp-controller="ProcessEnabler" asp-action="Index" id="form" method="post"
                              data-ajax="true"
                              data-ajax-method="POST"
                              data-ajax-mode="replace"
                              data-loading-text="loading..."
                              data-ajax-update="#ajaxresult"
                              data-ajax-success="fn_Onsuccess(data,'ApplicationManagement/ProcessEnabler/Index');"
                              data-ajax-failure="Errmsg(data);">
                            @Html.HiddenFor(m => m.Id)
                            <div class="pb-2 mt-4 mb-2 border-bottom box_title">
                                Function Dashboard
                            </div>
                            <div class="row">
                                <div class="col-12 text-center">
                                    <label>Select Organization Type</label>
                                    <div class="select_box m_bottom">
                                        <label class="radio-inline">
                                            <input type="radio" name="Organization" value="0" onclick="ManageOrganizationDiv(this)" checked>Parent Organization
                                        </label>
                                        <label class="radio-inline">
                                            <input type="radio" name="Organization" value="1" onclick="ManageOrganizationDiv(this)">Child Organization
                                        </label>
                                    </div>
                                </div>
                            </div>
                            <div class="mb-2 border-bottom box_title"></div>
                            <div class="row">
                                <div class="col-md-4 col-sm-6 col-xs-12" style="display:none;" id="divChildOrg">
                                    <label class="required">Child Company</label>
                                    <div class="select_box m_bottom">
                                        @Html.DropDownListFor(m => m.ChildOrgId, Model.DdlChildOrg, "Select Child Company", new { @class = "form-control m_no", onchange = "GetFunctionsByOrgId($('#Id').val(),$(this).val());" })
                                    </div>
                                </div>
                                <div class="col-md-4 col-sm-6 col-xs-12">
                                    <label class="required">Function</label>
                                    <div class="select_box m_bottom">
                                        <select class="form-control m_no" asp-for="FunctionId" onchange="GetProcessesByFunctionId(this)"><option value="0">Select Function</option></select>
                                    </div>
                                </div>
                                <div class="col-md-4 col-sm-6 col-xs-12" style="display:none;" id="divDdlProcess">
                                    <label class="required">Processes</label>
                                    <div class="select_box m_bottom">
                                        <select class="form-control m_no" id="ddlProcess" onchange="fnGetDomainCriticalityScore(this)"><option value="0">Select Function</option></select>
                                    </div>
                                </div>
                            </div>
                            <div class="row">
                                <div class="col-md-4 col-sm-6 col-xs-12 details_process" style="display:none">
                                    <label>Processes Consultant</label>
                                    <div class="select_box m_bottom">
                                        <input class="form-control m_no" value="@Context.Session.GetString("UserName")" readonly />
                                    </div>
                                </div>
                                <div class="col-md-4 col-sm-6 col-xs-12 details_process" style="display:none">
                                    <label>Process Description</label>
                                    <div class="select_box m_bottom">
                                        <textarea class="form-control m_no" id="ProDes" style="height:70px" readonly></textarea>
                                    </div>
                                </div>
                            </div>
                            <div style="display:none;" id="divDomainCriticalityScore">
                                <div class="pb-2 mt-4 mb-2 border-bottom box_title">Domain Criticality Score</div>
                                <div class="row">
                                    <div class="col-md-10 col-sm-6 col-xs-12">
                                        <div class="table_control">
                                            <table id="DomainCritical" class="table"></table>
                                        </div>
                                    </div>
                                </div>
                            </div>
                            <div class="row">
                                <div class="col-md-12 col-sm-6 col-xs-12">
                                    <div class="back_btn">
                                        <div class="back_btn_in">
                                            <input type="button" value="Back" onclick="fnBack()">
                                            <script>function fnBack() { $('[href="/ApplicationManagement/FunctionDashboard/Index"]').click() }</script>
                                        </div>
                                    </div>
                                    <div class="submitbtn" style="display:none;" id="divButton">
                                        <input type="button" id="btnsubmit" name="Submit" value="Submit" onclick="return prepareValueForSave()">
                                    </div>
                                </div>
                            </div>
                        </form>
                    </div>
                    <div class="assign_panel assign_section" id="dvDataTable">
                        <div class="assign_box active_block fade in">
                            <div class="row">
                                <div class="table_control">
                                    <table id="example2" class="table table-bordered table-hover">
                                        <thead>
                                            <tr>
                                                <th style="width:70px">SN</th>
                                                <th>Parent Organization Name</th>
                                                <th>Corporate Office Location</th>
                                                <th style="width:130px">Action</th>
                                            </tr>
                                        </thead>
                                        @{int sn = 0;}
                                        @foreach (var item in Model.OrganizationList)
                                        {
                                            <tr>
                                                <td>@(++sn)</td>
                                                <td>@item.ParentOrgName</td>
                                                <td>@item.CorporateOfficeLocation</td>
                                                <td>
                                                    <a data-ajax="true" data-ajax-method="GET" data-ajax-mode="replace" data-ajax-update="#ajaxresult" asp-action="Index" asp-route-parentOrgId="@item.Id" asp-controller="FunctionDashboard" asp-area="ApplicationManagement" class="edit_btn"></a>
                                                    @*<a data-ajax="true" data-ajax-method="GET" data-ajax-mode="replace" data-ajax-update="#ajaxresult" asp-action="BlockDeleteOrganization" asp-route-Id="@item.Id" asp-route-Type="0" asp-controller="Organization" asp-area="ApplicationManagement" class="Active_btn" asp-route-ActionName="@(item.IsActive ? "InActive" : "Active")"></a>*@
                                                    @*<a class="delete_btn" onclick="Confirmation('@item.Id')"></a>*@
                                                </td>
                                            </tr>
                                        }
                                        <tbody>
                                        </tbody>
                                    </table>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</section>
<script>
    function showForm() {
        $('#dvDataTable').hide();
        $('#dvForm').removeAttr('class');
    }
    function hideForm() {
        $('#dvDataTable').show();
        $('#dvForm').attr('class', 'service_line');
    }
    function ManageOrganizationDiv(checkbox) {
        var val = parseInt($(checkbox).val());
        if (val > 0) {
            $('#divChildOrg').show();
            $(".details_process").hide();
            $('#FunctionId').html('<option value="0">Select Function</option>');
            $("#ddlProcess").html('<option value="0">Select Process</option>');
        } else {
            $('#divChildOrg').hide();
            $('#divDdlProcess').hide();
            $(".details_process").hide();
            GetFunctionsByOrgId($('#Id').val(), 0);
            $('#divChildOrg').find('option:eq(0)').prop('selected', true);
        }
        $(".details_process").hide();
    }
    function GetFunctionsByOrgId(parentOrgId, childOrgId) {
        $("#divDdlProcess").hide();
        $(".details_process").hide();
        $('#FunctionId').empty();
        $.get('/ApplicationManagement/ProcessEnabler/GetFunctionsByOrgId', { parentOrgId: parentOrgId, childOrgId: childOrgId }, function (data) {
            var html = '<option value="0">Select Function</option>';
            $.each(data, function (i, item) {
                html += '<option value="' + item.id + '">' + item.functionName + '</option>'
            })
            $('#FunctionId').html(html);
        });
    }
    function GetProcessesByFunctionId(process) {
        var functionId = parseInt($(process).val());
        if (functionId > 0) {
            $.get('/ApplicationManagement/FunctionDashboard/GetProcesses', { functionId: functionId }, function (res) {
                $('#ddlProcess').empty();
                var html = '<option value="0">Select Process</option>';
                $.each(res, function (i, v) {
                    html += '<option value="' + v.id + '" id="' + v.description + '">' + v.processIdentified + '</option>';
                });
                $("#ddlProcess").append(html);
            })
            $("#divDdlProcess").show();
        }
        else {
            $("#ddlProcess").html('<option value="0">Select Process</option>');
        }
        $(".details_process").hide();
    }
    function OpenForm(parentOrgId) {
        $('#ParentOrgId').val(parentOrgId);
        var html = '<option value="0">Select Child Company</option>';
        $.get('/ApplicationManagement/FunctionDashboard/GetChildOrganizations', { parentOrgId: parentOrgId }, function (res) {
            $.each(res, function (i, v) {
                html += '<option value="' + v.id + '">' + v.childOrgName + '</option>';
            })
            $('#ChildId').html(html);
            $('#dvDataTable').hide();
            $('#dvForm').show();
        })
    }
    function fnGetFunctions(select) {
        var childOrgId = parseInt($(select).val());
        if (childOrgId > 0) {
            var html = '<option value="0">Select Function</option>';
            $.get('/ApplicationManagement/FunctionDashboard/GetFuncations', { childOrgId: childOrgId }, function (res) {
                $.each(res, function (i, v) {
                    html += '<option value="' + v.id + '">' + v.functionName + '</option>';
                })
                $('#FunctionId').html(html);
                $('#divFunction').show();
            })
        } else {
            $('#divFunction').hide();
            $('#divButton').hide();
            $('#divProcess').hide();
            $('.processDetails').hide();
            $('#divDomainCriticalityScore').hide();
        }
    }
    function fnGetProcesses(select) {
        var functionId = parseInt($(select).val());
        if (functionId > 0) {
            var html = '<option value="0">Select Processes</option>';
            $.get('/ApplicationManagement/FunctionDashboard/GetProcesses', { functionId: functionId }, function (res) {
                $.each(res, function (i, v) {
                    html += '<option value="' + v.id + '">' + v.processIdentified + '</option>';
                })
                $('#ProcessId').html(html);
                $('#divProcess').show();
            })
        } else {
            $('#divProcess').hide();
            $('#divButton').hide();
            $('.processDetails').hide();
            $('#divDomainCriticalityScore').hide();
        }
    }
    function fnGetDomainCriticalityScore(select) {
        var processId = parseInt($(select).val());
        var parentOrgId = parseInt($('#Id').val());
        var childOrgId = parseInt($('#ChildOrgId').val());
        var FunctionId = parseInt($('#FunctionId').val());

        var desc = $(select).find('option:selected').attr('id');
        //var parameters = [
        //    { Id: 1, Value: 'Financial' },
        //    { Id: 2, Value: 'Operational' },
        //    { Id: 3, Value: 'Reputational' },
        //    { Id: 4, Value: 'Regulatory' },
        //    { Id: 5, Value: 'Domain Criticality Score' }
        //]
        if (processId > 0) {
            var html = '';
            var thead = '<thead><tr><th style="text-align:center">Parameters</th>';
            var tbody = '<tbody>';
            $.get('/ApplicationManagement/FunctionDashboard/GetRiskDomainsByOrgId', { ParentOrgId: parentOrgId, ChildOrgId: childOrgId, FunctionId: FunctionId, ProcessId: processId }, function (res) {
                //if (res.length > 0) {
                //    $.each(res, function (i, v) {
                //        thead += '<th style="text-align:center;width:200px" id="' + v.riskDomainId + '">' + v.riskDomainName + '</th>';
                //    })
                //    thead += '</tr></thead>';
                //    $.each(parameters, function (ip, vp) {
                //        tbody += '<tr><td class="parameter" id="' + vp.Id + '">' + vp.Value + '</td>';
                //        $.each(res, function (i, v) {
                //            tbody += '<td class="parameter' + vp.Id + '"><input type="number" class="form-control RD_' + v.riskDomainId + '" min="1" max="5" onchange="calculateAverage(this)" /></td>';
                //        })
                //        tbody += '</tr>';
                //    })
                //    tbody += '</tbody>';
                //    html += thead;
                //    html += tbody;
                //    $('#DomainCritical').html(html);
                //    $('#divButton').show();
                //    $('#divDomainCriticalityScore').show();
                //}
                debugger
                if (res.html!="") {
                    $('#DomainCritical').html(res.html);
                    $('#divDomainCriticalityScore').show();
                    $('#divButton').show();
                }
                $('#ProDes').val(desc);
                $(".details_process").show();
            })
        } else {
            $('#divButton').hide();
            $(".details_process").hide();
            $('#divDomainCriticalityScore').hide();
        }
    }
    function calculateAverage(input) {
        debugger;
        var className = $(input).attr('class').split(' ')[1];
        var length = $('.' + className).length - 1;
        var value = 0;
        if (parseInt($(input).val()) < 1 || parseInt($(input).val()) > 5) {
            toastr.warning('Score should be between 1 to 5.');
            $(input).val('')
        } else {
            $('.' + className).each(function (i, ele) {
                debugger;
                if (i == length) {
                    $(ele).val((value / length).toFixed(2));
                } else {
                    value += parseInt($(ele).val());
                }
            })
        }
    }
    function prepareValueForSave() {
        debugger
        var parentOrgId = parseInt($('#Id').val());
        var childOrgId = parseInt($('#ChildOrgId').val());
        var functionId = parseInt($('#FunctionId').val());
        var processId = parseInt($('#ddlProcess').val());
        if (functionId<=0) {
            toastr.error('Please select function')
            return false;
        }
        if (processId <= 0) {
            toastr.error('Please select process')
            return false;
        }
        var DomainCriticalityScoreXML = [];
        $('.parameter').each(function (pI, pEle) {
            var parameterId = parseInt($(pEle).attr('id'));
            var domainScore = [];
            $('.parameter' + parameterId).each(function (dI, dEle) {
                var riskDomainId = parseInt($(dEle).find('input').attr('class').split(' ')[1].split('_')[1]);
                var score = parseFloat($(dEle).find('input').val());
                domainScore[dI] = {
                    RiskDomainId: riskDomainId,
                    Score: score
                }
            })
            DomainCriticalityScoreXML[pI] = {
                ParameterId: parameterId,
                RiskDomainScore: domainScore
            }
        })
        var model = {
            ParentOrgId: parentOrgId,
            ChildOrgId: childOrgId,
            FunctionId: functionId,
            ProcessId: processId,
            DomainCriticalityScoreXML: JSON.stringify(DomainCriticalityScoreXML)
        }
        $.post('/ApplicationManagement/FunctionDashboard/SubmitDomainCriticalityScore', { model: model }, function (res) {
            $('a[href="/ApplicationManagement/FunctionDashboard/Index"]').click();
            res.isSuccess ? toastr.error('Something went wrong!') : toastr.success('Saved successfully.');
        })
        console.log(DomainCriticalityScoreXML)
    }
</script>
